!- TRIANGULAR μOS 1.16 for Commodore VIC-20 8KB
!- GUI


!- Set variables & run GUI
1print"{clear}{142}":poke36879,8:q$=chr$(34):bd=peek(900):wd=peek(910):tc=peek(990):v$="1.16":tc$=chr$(tc):pp=peek(911):v=peek(992):h=peek(993):s1=peek(996):w1=peek(997):cg=peek(994):g1=peek(648)*256:mc$="{right}{reverse on}{cm g}                 {cm m}":bl$="{right*9}":ac=peek(991):ifac<1orac>5thenac=1
2onacgoto32,42,66,113,127

!- Cursor click handling
3v=v+1:ifv>21thenv=21
4return
5h=h-1:ifh<.thenh=.
6return
7h=h+1:ifh>20thenh=20
8return
9v=v-1:ifv<.thenv=.
10return
11poke198,.:pokec1,159:fori=.to150:nexti:pokec1,158:pokec1,cv:t=.:return

!- Store screen cell under cursor position
12c1=(v*22+h)+g1:cv=peek(c1):return

!- Load
13poke992,v:poke993,h:print"{clear}{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$n$q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- Time TI$ to hh:mm:ss parts
14t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):return

!- Parts of hh:mm:ss to time TI$
15t$=t1$+t2$+t3$:ti$=t$:return

!- Draw Background & taks panel
16print"{clear}"cg$;:fori=1to21:printbk$:nexti:gosub14:print"{white}{reverse on}         {cm asterisk}{sh pound}   "t1$":"t2$"{cm m}^{reverse off}":return

!- Joystick sterring
17gosub14:print"{home}"tab(14)"{white}{down*21}{reverse on}"t1$":"t2$:pokec1,cv:c1=(v*22+h)+g1:cv=peek(c1):pokec1,158:s=peek(37151):poke37154,127:t=peek(37152):poke37154,255:if(32ands)=.then11
18if(128andt)=.thengosub7
19if(16ands)=.thengosub5
20if(8ands)=.thengosub3
21if(4ands)=.thengosub9
22goto17

!- Joystick sterring SETTINGS olny
23gosub14:print"{home}{white}{down*3}"tab(8)"{reverse on}"t1$":"t2$":"t3$"{down*18}{reverse on}{left*2}"t1$":"t2$:pokec1,cv:c1=(v*22+h)+g1:cv=peek(c1):pokec1,158:s=peek(37151):poke37154,127:t=peek(37152):poke37154,255:if(32ands)=.then11
24if(128andt)=.thengosub7
25if(16ands)=.thengosub5
26if(8ands)=.thengosub3
27if(4ands)=.thengosub9
28goto23

!- Save settings to uos.cfg & Store in memory cursor position
29poke992,v:poke993,h:poke996,s1:poke997,w1:poke994,cg:poke911,pp:poke990,tc:poke910,wd:open1,bd,15,"s0:uos.cfg":close1:open8,bd,8,"uos.cfg,w,s":print#8,v$:print#8,wd:print#8,peek(909):print#8,s1:print#8,w1:print#8,cg::print#8,tc:print#8,pp:close8:open1,bd,15:input#1,n,n$,n,n:close1:return


!- Update color variables
30bk$="":ifs1=1thenbk$="{reverse on}"
31bt$=chr$(w1):cg$=chr$(cg):fori=.to20:bk$=bk$+bt$:nexti:return


!- DESKTOP loop
32poke991,1:gosub30:gosub16:gosub64:gosub12
33gosub17
34ifv>1andh>2andv<7andh<8then43
35ifv>1andh>11andv<7andh<17then127
36ifv>11andh>2andv<17andh<8then113
37ifv>11andh>11andv<17andh<17then66
38ifv=21andh>8andh<11thengosub56
39ifr=2thenr=.:gosub30:gosub16:gosub64:gosub12:goto34
40ifr=1thenr=.:goto32

41goto33


!- Draw THIS VIC icons
42gosub30:gosub16:gosub64
43poke991,2:gosub63:print"{home}{down*2}{right*2}{reverse on}"tc$"this vic{return}{down}{right*3}{reverse off}{blue}      {return}{right*3}{reverse off}{blue}      {right*2}     {reverse on}{return}{right*3}{reverse off}{blue}  {white}UI{blue}  {right*2}{blue} {cyan}8>{blue}  {return}{right*3}{reverse off}{blue}  {white}JK{blue}  {right*2}{blue}     {return}{right*3}{reverse off}{blue}      {right*2} {cyan}8>${blue} {return}{right*3}{reverse off}{blue}   {white}{cm m}P{blue} {right*2}     {return}{down}{right*4}{reverse on}{cyan}disk{right*4}cmd{return}{down*9}{white}{reverse on}this vic":gosub12

!- THIS VIC loop
44gosub17
45ifv>13andh>2andv<17andh<8then113
46ifv>13andh>11andv<17andh<17then66
47ifv=2andh=16thenr=.:goto32
48ifv>3andh>2andv<10andh<9thenn$="disk":goto13
49ifv>4andh>10andv<10andh<16thenn$="cmd":goto13
50ifv=21andh=20thenr=.:goto32
51ifv=21andh>8andh<11thengosub56
52ifr=2thenr=1:goto45
53ifr=1thenr=.:goto42
54goto44

!- Run THIS VIC as 1st window
55gosub30:gosub16:gosub64:goto42


!- Draw Start Menu
56print"{home}{white}{down*14}"bl$"{reverse on}O{cm t*9}P{return}"bl$"{reverse on}{cm g}settings {cm m}{return}"bl$"{reverse on}{cm g}         {cm m}{return}"bl$"{reverse on}{cm g}restart  {cm m}{return}"bl$"{reverse on}{cm g}         {cm m}{return}"bl$"{reverse on}{cm g}shut down{cm m}{return}"bl$"{reverse on}L{cm @*9}{sh @}"

!- Start Menu loop
57gosub12:gosub17:ifv=21andh>8andh<11thenr=1:return
58ifv<14orh<9orh>19orv>20thenr=2:return
59ifv=15andh>9andh<18then66
60ifv=17andh>9andh<17thenn$="uos":goto13
61ifv=19andh>9andh<19thensys64802
62goto57

!- Draw window
63print"{home}"tc$"{down*2}{right}{reverse on}              {cm m}{red}V"tc$"{cm g}{white}{return}{right}{reverse on}O{cm t*15}P":forj=1to9:print"{right}{reverse on}{cm g}               {cm m}":nextj:print"{right}{reverse on}L{cm @*15}{sh @}":return


!- Draw DESKTOP icons
64print"{home}{white}{down*2}{right*3}{cm d}{cm i*2}{cm f}{reverse on}{yellow}M{white}"tab(12)"{reverse off}{blue}  {red}Q{blue}  {reverse on}{return}{right*3}{reverse on}{white}{cm k}8>{reverse off}{cm k}{reverse on}{yellow}{cm m}{white}"tab(12)"{up}{down}{blue}{reverse off}  {white}B{blue}  {reverse on}{return}{right*3}{reverse on}{white}{cm k}9>{reverse off}{cm k}{reverse on}{yellow}{cm m}{white}"tab(12)"{reverse off}{blue}  {white}B{blue}  {reverse on}{return}{right*3}{white}{cm c}{reverse on}{cm i*2}{reverse off}{cm v}{reverse on}{yellow}N{white}"tab(12)"{up}{down}{reverse off}{blue} {reverse on}{white}{sh pound}.{cm asterisk}{reverse off}{blue} {reverse on}{return}{right*3}{yellow}{cm b*4}{white}"tab(12)"{reverse off}{blue}   M {return}{right*2}{down}{reverse on}{cyan}this vic{right*2}games{down*3}"
65print"{right*3}{white}{reverse on}math{red}V"tab(12)"{blue}{reverse off} {reverse on}{yellow}{sh pound}{blue}{reverse off} {reverse on}{yellow}{cm asterisk}{reverse off}{blue} {return}{right*3}{white}{reverse on}{cm t*5}"tab(12)"{blue}{reverse off} {yellow}{reverse on}   {reverse off}{blue} {return}{right*3}{white}{reverse on} {green}a{white}:2 "tab(12)"{blue}{reverse off} {yellow}{cm asterisk}{reverse on} {reverse off}{sh pound}{blue} {return}{right*3}{white}{reverse on} {blue}b{white}:0 "tab(12)"{blue}{reverse off}  {yellow}{reverse on} {reverse off}{blue}  {return}{right*3}{white}{reverse on}     "tab(12)"{blue}{reverse off}  {reverse on}{yellow} {reverse off}{blue}  {return}{reverse on}{right*3}{down}{cyan}apps{right*4}settings":return


!- SETTINGS loop
66poke991,3:gosub30:gosub16:gosub102:gosub12
67gosub104:gosub23
68ifv=1andh=18then32
69ifv=21andh=20thenpoke991,1:goto32
70ifv=4andh=8thengosub14:t0$=t1$:gosub96:t1$=t0$:gosub15
71ifv=4andh=11thengosub14:t0$=t2$:gosub92:t2$=t0$:gosub15
72ifv=4andh=14thengosub14:t0$=t3$:gosub92:t3$=t0$:gosub15
73ifv=4andh=9thengosub14:t0$=t1$:gosub98:t1$=t0$:gosub15
74ifv=4andh=12thengosub14:t0$=t2$:gosub94:t2$=t0$:gosub15
75ifv=4andh=15thengosub14:t0$=t3$:gosub94:t3$=t0$:gosub15
76ifv=6andh>1andh<13thenti$="000000"
77ifv=16andh>2andh<9thenn$="colors":goto13

78ifv=10andh>1andh<4theni=.:gosub111
79ifv=10andh>5andh<8theni=1:gosub111
80ifv=10andh>9andh<13theni=2:gosub111
81ifv=10andh>14andh<18theni=3:gosub111

82ifv=13andh>1andh<4thenpp=.
83ifv=13andh>4andh<7thenpp=4
84ifv=13andh>7andh<10thenpp=5
85ifv=13andh>10andh<13thenpp=6
86ifv=13andh>13andh<16thenpp=7

87ifv=16andh>12andh<18thengosub29
88ifv=21andh>8andh<11thengosub56
89ifr=2thenr=1:goto68
90ifr=1thenr=.:goto66
91goto67

!- Time change
92t=val(t0$):t=t+1:ift>59thent=.
93gosub100:return
94t=val(t0$):t=t-1:ift<.thent=59
95gosub100:return
96t=val(t0$):t=t+1:ift>23thent=.
97gosub100:return
98t=val(t0$):t=t-1:ift<.thent=23
99gosub100:return
100t0$=str$(t):ift>9thent0$=right$(t0$,2):return
101t0$=right$(t0$,1):t0$="0"+t0$:return


!- Draw SETTINGS
102print"{home}{down}{right}{reverse on}"tc$" settings       {cm m}{red}V"tc$"{cm g}{white}{return}{right}{reverse on}O{cm t*17}P{return}{right}{reverse on}{cm g}time:            {cm m}{return}{right}{reverse on}{cm g}      {cyan}+-{white} {cyan}+-{white} {cyan}+-{white}   {cm m}{return}"mc$"{return}{right}{reverse on}{cm g}{yellow}reset clock{white}      {cm m}{return}"mc$"{return}"mc$
103print"{right}{reverse on}{cm g}work disk:       {cm m}{return}"mc$"{return}"mc$"{return}{right}{reverse on}{cm g}printer:         {cm m}{return}"mc$"{return}"mc$"{return}"mc$"{return}{right}{reverse on}{cm g} {blue}c{purple}o{red}l{yellow}o{green}r{cyan}s{white}    {green}apply{white} {cm m}{return}"mc$"{return}{right}{reverse on}L{cm @*17}{sh @}{down*2}{return}{white}{reverse on}settings":return


!- Show disk & printer labels
104print"{home}{down*10}{right*2}{reverse on}";:i=.:gosub105:printoo$"8>{white}  ";:gosub105:printoo$"{reverse on}9>{white}  ";:gosub105:printoo$"{reverse on}10>{white}  ";:gosub105:printoo$"{reverse on}11>{white}{return}{down*2}{right*2}{reverse on}";:i=.:gosub109:printoo$"no{white} ";:i=4:gosub109:printoo$"#4{white} ";:gosub109:printoo$"{reverse on}#5{white} ";:gosub109:printoo$"{reverse on}#6{white} ";:gosub109:printoo$"{reverse on}#7{white}":return


!- Show disk label set color
105ifpeek(901+i)=.thenoo$="{red}":goto108
106ifpeek(901+i)=1thenoo$="{cyan}"
107ifwd=8+ithenoo$="{green}"
108i=i+1:return


!- Show printer label set color
109oo$="{red}":ifpp=ithenoo$="{green}"
110i=i+1:return


!- Change disk
111ifpeek(901+i)=1thenwd=8+i:gosub104:return
112return


!- APPS loop
113 poke991,4:gosub30::gosub16:gosub125:gosub12
114 gosub17
115 ifv=1andh=18then32
116 ifv=21andh=20thenpoke991,1:goto32
117 ifv>2andh>2andv<8andh<8thenn$="words":goto13
118 ifv>2andh>11andv<8andh<17thenn$="math":goto13
119 ifv>10andh>2andv<16andh<8thenn$="monitor":goto13
120 ifv>10andh>11andv<16andh<17thenn$="synth":goto13

121 ifv=21andh>8andh<11thengosub56
122 ifr=2thenr=1:goto115
123 ifr=1thenr=.:goto113

124 goto114


!- Draw APPS window & icons
125 print"{home}{down}{right}{reverse on}"tc$" apps           {cm m}{red}V"tc$"{cm g}{white}{return}{right}{reverse on}O{cm t*17}P":fori=.to14:printmc$:nexti:print"{right}{reverse on}L{cm @*17}{sh @}{return}{white}{down*2}{reverse on}{right*4}apps{return}{home}{down*3}{right*3}{white}{reverse on}O{cm t*3}P"tab(12)"{reverse on}{white}O{cm t*3}P{return}{right*3}{reverse on}{white}{cm g}abc{cm m}{reverse on}"tab(12)"{reverse on}{white}{cm g}{green}a{white}:2{cm m}{return}{right*3}{reverse on}{white}{cm g}def{cm m}{reverse on}"tab(12)"{reverse on}{white}{cm g}{blue}b{white}:0{cm m}{return}{right*3}{reverse on}{white}{cm g}123{cm m}{reverse on}"tab(12)"{reverse on}{white}{cm g}{cyan}+{white} {cyan}*{white}{cm m}"
126 print"{right*3}{reverse on}{cm asterisk}{cm @*3}{sh @}"tab(12)"{reverse on}{white}L{cm @*3}{sh @}{return}{reverse on}{right*3}{down}{cyan}words{right*4}math{return}{down}{right*3}{reverse on}{blue}*:   "tab(12)"{reverse on}{white}O{cm t*3}P{return}{right*3}{reverse on}{blue}$1e00"tab(12)"{reverse on}{white}{cm g}{cm m}M{cm m}{cm m}{return}{right*3}{reverse on}{blue} $32 "tab(12)"{reverse on}{white}{cm g}{cm m} {cm m}{cm m}{return}{right*3}{reverse on}{blue}$1e01"tab(12)"{reverse on}{white}{cm g}Q W{cm m}{return}{right*3}{reverse on}{blue} $30 "tab(12)"{reverse on}{white}L{cm @*3}{sh @}{return}{reverse on}{right*2}{down}{cyan}monitor{right*3}synth":return


!- GAMES loop
127 poke991,5:gosub30:gosub16:gosub139:gosub12
128 gosub17
129 ifv=1andh=18then32
130 ifv=21andh=20thenpoke991,1:goto32
131 ifv>2andh>2andv<8andh<8thenn$="simcity":goto13
132 ifv>2andh>11andv<8andh<17thenn$="star wars":goto13
133 ifv>10andh>2andv<16andh<8thenn$="breakout":goto13
134 ifv>10andh>11andv<16andh<17thenn$="need4vic":goto13

135 ifv=21andh>8andh<11thengosub56
136 ifr=2thenr=1:goto129
137 ifr=1thenr=.:goto127

138 goto128


!- Draw GAMES window & icons
139 print"{home}{down}{right}{reverse on}"tc$" games          {cm m}{red}V"tc$"{cm g}{white}{return}{right}{reverse on}O{cm t*17}P":fori=.to14:printmc$:nexti:print"{right}{reverse on}L{cm @*17}{sh @}{return}{white}{down*2}{reverse on}{right*3}games{return}{home}{down*3}{right*3}{reverse on}{red}  {reverse off}:{reverse on}  "tab(12)"{reverse off}{white}N{blue}   {white}M{return}{right*3}{reverse on}{red} {green}r{reverse off}{red}:{reverse on}{green}r{red} "tab(12)"{reverse off}{white}{cm g}{reverse on}{sh pound}"q$;q$"{left}{cm asterisk}{reverse off}{cm m}{return}{right*3}{reverse on}{red}{reverse off}:::::{reverse on}"tab(12)"{reverse off}{white}O{cm asterisk}{reverse on}W{reverse off}{sh pound}P{return}{right*3}{reverse on}{red} {blue}c{reverse off}{red}:{reverse on}{yellow}i{red} "tab(12)"{reverse off}{white}M{blue} {yellow}W{blue} {white}N"
140 print"{right*3}{reverse on}{red}  {reverse off}:{reverse on}  "tab(12)"{reverse off}{blue} {yellow}W{blue}   {return}{reverse on}{right*2}{down}{cyan}simcity{right}star wars{return}{down}{right*3}{reverse off}{blue} {purple}{reverse on}PPP{blue}{reverse off} "tab(12)"{reverse off}   {yellow}{cm @*2}{return}{right*3}{reverse off}{blue} {green}{reverse on}PPP{blue}{reverse off} "tab(12)"{reverse off}  {yellow}{cm c}{white}W{reverse on}{yellow}{cm i}{return}{right*3}{reverse off}{blue}     "tab(12)"{reverse off} {red}{cm @*2}{cm i}{cm p}{return}{right*3}{blue}   {white}Q{blue} "tab(12)"{reverse off}{red}{cm c}{white}W{reverse on}{red}{cm i*2}{reverse off}{white}W{return}{right*3}{reverse off}{blue}  {white}{cm u}{blue}  "tab(12)"{reverse off}{blue}     {return}{reverse on}{right*2}{down}{cyan}breakout{right}need4vic":return
